#ifndef __TEXTURES_H__
#define __TEXTURES_H__

#include <gearlib.h>
#include <stdint.h>

void setup_textures();
uint32_t load_texture(const char* path);
void draw_texture(uint32_t id, vec3 pos, vec4 color);
void batch_draw_texture(RenderBatch* batch, uint32_t id, vec3 pos, vec4 color);
RenderBatch* create_texture_quad_batch();

extern RenderBatch* texture_quad_batch;
extern int max_textures;

typedef struct {
    vec3 Position;
    vec4 Tint;
    vec2 TexCoord;
    float TexID;
} TextureQuadVertex;

typedef struct {
    float texture_index;
} TextureQuadBatchData;

#endif
